﻿using System;
using System.IO.Ports;
using System.IO;
using System.Windows.Forms;
using System.Threading.Tasks;

namespace MLVS_USB_Serial_Example //MLVS USB Comm port example D.S. 3-12-18
{
    public partial class Form1 : Form
    {
        string RxString, ComPort = "5", SendData, Model, SerialNumber;
        bool b;

        public Form1()
        {
            InitializeComponent();
            Show(); //show form1
            serialPort1.ReadTimeout = 500; // Set the read/write timeouts
            serialPort1.WriteTimeout = 500;
            txtComPort.Text = ComPort;
            btnConnect.PerformClick(); //call Connect to port routine
            txtSent.Focus(); //textbox gets focus for data entry
            AcceptButton = btnSend; //set button to default on form1
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private async void Send_ClickAsync(object sender, EventArgs e)
        {
            SendData = txtSent.Text;
            serialPort1.Write(SendData + "\r"); //write ASCII string + carriage return

            await Task.Delay(100); //wait xx milliseconds before read

            txtReceived.Text = "";
            RxString = "";
            RxString = serialPort1.ReadExisting(); //read return data
            txtReceived.Text = RxString;
            txtSent.SelectionStart = 0; //select text in textbox
            txtSent.SelectionLength = txtSent.Text.Length;
        }

        private async void btnConnect_ClickAsync(object sender, EventArgs e)
        {
            ComPort = txtComPort.Text; //set com port to "COMxx"
            try
            {
                //set the appropriate properties for port.
                if (serialPort1.IsOpen) serialPort1.Close();
                serialPort1.PortName = "COM" + ComPort;
                serialPort1.BaudRate = 9600;
                serialPort1.Parity = Parity.None;
                serialPort1.StopBits = StopBits.One;
                serialPort1.Handshake = Handshake.None;
                serialPort1.Open(); //open serial port
            }

            catch (IOException)
            {
                txtStatus.Text = "Not an active port, please check COM #";
                txtModel.Text = "";
                txtSerialNumber.Text = "";
                txtSent.Text = "";
                txtReceived.Text = "";
            }

            if (serialPort1.IsOpen)
            {
                Model = "";
                SendData = "R0";
                serialPort1.Write(SendData + "\r"); //write ASCII string + carriage return

                await Task.Delay(100); //wait xx milliseconds before read

                txtReceived.Text = "";
                RxString = "";
                RxString = serialPort1.ReadExisting(); //read return data
                Model = RxString;
                txtModel.Text = Model;

            if (b = RxString.Contains("MLVS"))
                {
                    txtStatus.Text = "MLVS Unit Connected on " + serialPort1.PortName;

                    SerialNumber = "";
                    SendData = "R1";
                    serialPort1.Write(SendData + "\r"); //write ASCII string + carriage return

                    await Task.Delay(100); //wait xx milliseconds before read

                    txtReceived.Text = "";
                    RxString = "";
                    RxString = serialPort1.ReadExisting(); //read return data
                    SerialNumber = RxString;
                    txtSerialNumber.Text = SerialNumber;
                }

            else
                {
                    txtStatus.Text = serialPort1.PortName + " is an active port, but not an MLVS unit";
                    txtModel.Text = "";
                    txtSerialNumber.Text = "";
                    txtSent.Text = "";
                    txtReceived.Text = "";
                }
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (serialPort1.IsOpen) serialPort1.Close();
        }

        private void Exit_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
            {
                serialPort1.Close(); //if open, close serial port on exit
            }
            Environment.Exit(1); //exit program   
        }
    }
}
        